#include <iostream>
#include "global.h"

void dragselect_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XbaeMatrixSelectCellCallbackStruct *drag=(XbaeMatrixSelectCellCallbackStruct *) call_data;
  int row, col, nrow, ncol;
  int dx, dy, i, j;
  short is_first;

  row=drag->row; col=drag->column;
  XtVaGetValues(StatData, XmNcolumns, &ncol, NULL);
  XtVaGetValues(StatData, XmNrows, &nrow, NULL);
  // is it the first cell in the rectangle ?;
  XbaeMatrixFirstSelectedCell(StatData, &i, &j);
  if (i==-1 && j==-1) is_first=1; else is_first=0;

  if (is_first) {
    reg.col1=col; reg.row1=row;
    reg.col2=col; reg.row2=row;
    XbaeMatrixSelectCell(StatData,row,col);
  }
  else {
    XbaeMatrixDeselectAll(StatData);
    if (row>reg.row1) dy=1; else dy=-1;
    if (col>reg.col1) dx=1; else dx=-1;
    for (i=reg.row1; i!=row+dy; i+=dy)
      for (j=reg.col1; j!=col+dx; j+=dx) {
	XbaeMatrixSelectCell(StatData,i,j);
      }
    reg.col2=col; reg.row2=row;
  }
}

void entercell_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XbaeMatrixEnterCellCallbackStruct *drag=(XbaeMatrixEnterCellCallbackStruct *) call_data;
  
  reg.col1=drag->column; reg.col2=reg.col1;
  reg.row1=drag->row; reg.row2=reg.row1;

  XbaeMatrixDeselectAll(StatData);
}
